#|

 Copyright (C) 1994 by Computational Logic, Inc.  All Rights Reserved.

 This script is hereby placed in the public domain, and therefore unlimited
 editing and redistribution is permitted.

 NO WARRANTY

 Computational Logic, Inc. PROVIDES ABSOLUTELY NO WARRANTY.  THE EVENT SCRIPT
 IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED,
 INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND
 PERFORMANCE OF THE SCRIPT IS WITH YOU.  SHOULD THE SCRIPT PROVE DEFECTIVE, YOU
 ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 IN NO EVENT WILL Computational Logic, Inc. BE LIABLE TO YOU FOR ANY DAMAGES,
 ANY LOST PROFITS, LOST MONIES, OR OTHER SPECIAL, INCIDENTAL OR CONSEQUENTIAL
 DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THIS SCRIPT (INCLUDING BUT
 NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES
 SUSTAINED BY THIRD PARTIES), EVEN IF YOU HAVE ADVISED US OF THE POSSIBILITY OF
 SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER PARTY.
|#

(IN-PACKAGE "USER")

(EVAL-WHEN (LOAD EVAL COMPILE)
	   (CHK-BASE-AND-PACKAGE-1992 10 *PACKAGE*))

(defparameter *mods-alist*
  (if (boundp '*mods-alist*)		;so it can work with Nqthm-1987
      (if (not (assoc-eq 'nqthm-setq *mods-alist*))
	  (cons (cons 'nqthm-setq
		      "With this facility, doing (NQTHM-SETQ <name> <form>)
in Lisp has the same effect as doing (SETQ <name> <form>)
inside R-LOOP.")
		*mods-alist*)
	*mods-alist*)
    nil))

(defun nqthm-setq-fn (var form &aux ans)
  (cond ((nvariablep (translate var))
	 (er soft (var) |The| |first| |argument| |to| NQTHM-SETQ
	     |must| |be| |a| |variable| |,| |but| (!ppr var nil) |is| |not| |.|))
	(t
	 (setq ans (reduce-term (translate-and-chk form) r-alist))
	 (cond ((not (eq ans (quote *1*failed)))
		(cond ((setq temp-temp (assoc-eq var r-alist))
		       (rplacd temp-temp (cadr ans)))
		      (t (setq r-alist
			       (cons (cons var (cadr ans))
				     r-alist))))
		(untranslate ans))
	       (t (er soft (form) |Result| |of| |evaluating| |form|
		      (!ppr form nil) |was| NOT REDUCIBLE |.|))))))

(defmacro nqthm-setq (var form)
  `(nqthm-setq-fn ',var ',form))
