;;; -*-  Mode: Lisp; Package: USER; Syntax: Common-Lisp; Base: 10 -*- ;;;;

;  Copyright (C) 1994 by Computational Logic, Inc.
;  All Rights Reserved.

;  Copying of this file is authorized to those who have read and
;  agreed with the terms in the "Pc-Nqthm-1992 GENERAL PUBLIC SOFTWARE
;  LICENSE" at the beginning of the Pc-Nqthm file "basis-pc.lisp".

;  Pc-Nqthm Version 1992 (for use with Nqthm-1992)

(IN-PACKAGE "USER")

(EVAL-WHEN (LOAD EVAL COMPILE)
	   (CHK-BASE-AND-PACKAGE-1992 10 *PACKAGE*))

;;; This file no longer redefines any functions in the
;;; Boyer-Moore theorem prover.  The rather large
;;; number of modifications that were here in previous versions
;;; have mainly been incorporated, more or less, into Nqthm-1992.

;;; Note:  The redefinition of STORE-SENT appears in (and is explained
;;; in) top-nqthm.lisp rather than here, because it needs otf-flg
;;; declared special.

;;; The final two functions in this file are there for convenience,
;;; since forms in basis-pc.lisp depend on them.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;			    NEW DISCLAIMER                       ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; I've been debating whether to force the disclaimer on, and have
;; finally decided to comment out the following form.  However
;; Nqthm has been built, I can live with the same decision.
;(SETQ *THM-SUPPRESS-DISCLAIMER-FLG* NIL)

(DEFPARAMETER *THM-DISCLAIMER* 

"

NQTHM Version 1992.  See the license agreement at the beginning of the
Nqthm-1992 file \"basis.lisp\" for the terms and conditions on the use
and modification of this software.

Robert S. Boyer and J Strother Moore

Pc-Nqthm Version 1992.  See the license agreement at the beginning of
the Pc-Nqthm-1992 file \"basis-pc.lisp\" for the terms and conditions
on the use and modification of this software.

Matt Kaufmann

To avoid this warning, (SETQ *THM-SUPPRESS-DISCLAIMER-FLG* T).

")

(defparameter *mods-alist*
  (if (not (assoc-eq 'pc-nqthm-1992 *mods-alist*))
      (cons (cons 'pc-nqthm-1992
		  "You are using the Pc-Nqthm-1992 ``interactive enhancement''
of the Boyer-Moore theorem prover, Nqthm-1992.  All modifications of
functions and variables in the Boyer-Moore Theorem Prover appear in
the source files \"nqthm-patches.lisp\" and \"top-nqthm.lisp\".  In
particular, the PROVE-LEMMA and DEFN events have been modified to
support an interactive capability, and a DEFN-SK event has been added
to support first-order quantification.")
	    *mods-alist*)
    *mods-alist*))

(defun convert-alist-to-eq-hash-table (alist &optional size)
  (let ((h (make-hash-table :test #'eq :size (or size (+ (length alist) 10)))))
    (iterate for pair in alist
	     do (setf (gethash (car pair) h) (cdr pair)))
    h))

(defmacro get-instr-info (instr-name)
  ;; could change this back to (assoc-eq instr-name instructions) as
  ;; long as I change INSTRUCTIONS back to an alist
  `(gethash ,instr-name instructions))
